module(..., package.seeall)

-- Load libraries
require("controllerfunctions")

default_action = "status"

function status(self)
	return self.model.getstatus()
end

function startstop(self)
	return controllerfunctions.handle_startstop(self, self.model.startstop_service, self.clientdata)
end

function config(self)
	return controllerfunctions.handle_form(self, self.model.getconfig, self.model.setconfig, self.clientdata, "Save", "Edit Config", "Configuration Set")
end

function expert(self)
	return controllerfunctions.handle_form(self, self.model.getconfigfile, self.model.setconfigfile, self.clientdata, "Save", "Edit Config File", "Configuration File Set")
end

function editips(self)
	return controllerfunctions.handle_form(self, self.model.getIPs, self.model.setIPs, self.clientdata, "Save", "Edit IP List", "IP List Set")
end

function listdomains(self)
	return self.model.getDomains()
end

function createdomain(self)
	return controllerfunctions.handle_form(self, self.model.getNewDomain, self.model.setNewDomain, self.clientdata, "Create", "Create New Domain", "New Domain Created")
end

function editdomain(self)
	return controllerfunctions.handle_form(self, function(form) return self.model.getDomain(self.clientdata.domain) end,
		self.model.setDomain, self.clientdata, "Save", "Edit Domain Entry", "Domain Saved")
end

function deletedomain(self)
	return self:redirect_to_referrer(self.model.deleteDomain(self.clientdata.domain))
end
